
asteroids = {}

local maxVel = 100

local textures = {
love.graphics.newImage("assets/asteroid1.png"),
love.graphics.newImage("assets/asteroid2.png"),
}

function updateAsteroids(dt)
	for i=#asteroids,1,-1 do
		--Sort out off screen collisions
		if asteroids[i].position.x<=0 or asteroids[i].position.x>=800 then
			asteroids[i].velocity.x = -asteroids[i].velocity.x
			if asteroids[i].position.x>=800 then --Stop it vibrating at low speeds
				asteroids[i].position.x = 799
			else
				asteroids[i].position.x = 1 
			end
		end
		if asteroids[i].position.y<=0 or asteroids[i].position.y>=800 then
			asteroids[i].velocity.y = -asteroids[i].velocity.y
			if asteroids[i].position.y>=800 then --Stop it vibrating at low speeds
				asteroids[i].position.y = 799
			else
				asteroids[i].position.y = 1 
			end
		end
		
		if asteroids[i].velocity:magnitude()>maxVel then
			asteroids[i].velocity = asteroids[i].velocity:unit()*maxVel
		end
		
		--Update the position
		asteroids[i].position = asteroids[i].position+asteroids[i].velocity*dt
		
		for j=1,4 do
			local pl = planets[j]
			if (pl.position-asteroids[i].position):magnitude()<142 and pl.alive then
				pl.alive = false --Kill the planet
				table.remove(asteroids,i)
			end
		end
	end
	for i=1,#asteroids-1 do
		local a = asteroids[i]	
		for j=i+1,#asteroids do
			local b = asteroids[j]
			if a~=b and (a.radius+b.radius)>=(a.position-b.position):magnitude() then
				local totalVel = a.velocity-b.velocity
				a.velocity = (a.velocity*(a.radius-b.radius) + 2*b.radius*b.velocity)/(a.radius+b.radius)
				b.velocity = totalVel+a.velocity
				
				local mid = (a.position+b.position)/2
				local dist = (a.position-b.position):magnitude()
				a.position = mid + (a.radius+1)*(a.position-b.position)/dist
				b.position = mid + (b.radius+1)*(b.position-a.position)/dist
			end
		end
	end
end

function drawAsteroids()
	for i=1,#asteroids do
		local a = asteroids[i]
		love.graphics.draw(a.image,a.position.x,a.position.y,a.rotation,a.radius/(a.image:getWidth()/2),a.radius/(a.image:getHeight()/2),a.image:getWidth()/2,a.image:getHeight()/2)
	end
end

function generateAsteroids()
	maxVel = 100*difficulty
	asteroids = {}
	for i=1,difficulty*math.random(5,10) do
		asteroids[i] = {
			position = vector:new(math.random(800),math.random(800)),
			velocity = vector:new(math.random(10,20)*difficulty,math.random(10,20)*difficulty),
			radius = math.random(5,20),
			rotation = math.random(7)-1, --Roughly 0-2pi so it can have any rotation
			image = textures[math.random(#textures)]
		}
		--Stop asteroids spawning on the planets
		if (asteroids[i].position.x<200 or asteroids[i].position.x>600) and (asteroids[i].position.y<200 or asteroids[i].position.y>600) then
			local rand = math.random(3)
			if rand==1 then --Fairly distribute them in the cross
				asteroids[i].position.y = math.random(200,600)
			elseif rand==2 then
				asteroids[i].position.x = math.random(200,600)
			else
				asteroids[i].position.x = math.random(200,600)
				asteroids[i].position.y = math.random(200,600)
			end
		end
	end
end