
local planetBase = love.graphics.newImage("assets/planetBase.png")
local seas = {
	love.graphics.newImage("assets/planetSea1.png"),
	love.graphics.newImage("assets/planetSea2.png"),
}

planets = {}

function generatePlanets()
	planets = {}
	for i=1,4 do
		planets[i] = {
		position = vector:new(((i-1)%2) * 800,(math.ceil(i/2)-1) * 800),
		base = {math.random(255),math.random(255),math.random(255)},
		sea = {math.random(255),math.random(255),math.random(255)},
		seas = {},
		rot = {},
		alive = true,
		}
		for j=1,#seas do
			if math.random(5)~=1 then
				planets[i].seas[#planets[i].seas+1] = seas[j]
				planets[i].rot[#planets[i].rot+1] = math.random(628)/100
			elseif math.random(10)==1 then
				planets[i].seas[#planets[i].seas+1] = seas[j]
				planets[i].seas[#planets[i].seas+1] = seas[j]
				planets[i].rot[#planets[i].rot+1] = math.random(628)/100
				planets[i].rot[#planets[i].rot+1] = math.random(628)/100
			end
		end
	end
end

function drawPlanets()
	for i=1,#planets do
		local pl = planets[i]
		love.graphics.setColor(pl.base)
		love.graphics.draw(planetBase,pl.position.x,pl.position.y,0,1,1,planetBase:getWidth()/2,planetBase:getHeight()/2)
		love.graphics.setColor(pl.sea)
		for j=1,#pl.seas do
			love.graphics.draw(pl.seas[j],pl.position.x,pl.position.y,pl.rot[j],1,1,planetBase:getWidth()/2,planetBase:getHeight()/2)
		end
		if not pl.alive then
			love.graphics.setColor(0,0,0,200)
			love.graphics.circle("fill",pl.position.x,pl.position.y,142)
		end
		love.graphics.setColor(255,255,255)
	end
end
